<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Propaganda Detector UI</title>
    <style>
        .tag {
            border: 1px rgba(0, 0, 0, 0.1) solid;
            border-radius: 3px;
            padding: 1px;
            opacity: 0.7;
            transition: opacity 0.2s;
        }

        .tag:hover {
            opacity: 1;
        }

        .popup {
            position: absolute;
            background: white;
            padding: 5px 20px;
            box-shadow: 5px 5px 20px rgba(0,0,0,0.4);
            border-radius: 8px;
            border: 1px #cbcbcb solid;
            max-width: 27em;
        }

        .popup::before {
            content: '';
            position: absolute;
            top: 50%;
            right: 100%;
            transform: translate(calc(50% - 1px), -50%) rotate(45deg);
            width: 9px;
            height: 9px;
            background-color: white;
            border-left: 1px #cbcbcb solid;
            border-bottom: 1px #cbcbcb solid;
        }

        body {
            font-family: Arial, sans-serif;
            background-color: #f5f5f5;
            margin: 0;
            padding-bottom: 5em;
        }

        .container {
            max-width: 800px;
            margin: 0 auto;
            padding: 20px;
        }

        .text-input {
            width: 100%;
            height: 200px;
            padding: 10px;
            margin-bottom: 20px;
            font-size: 16px;
            border: 1px solid #ccc;
            border-radius: 5px;
            box-sizing: border-box;
        }

        .file-input {
            margin-bottom: 20px;
        }

        .button {
            padding: 10px 20px;
            font-size: 16px;
            background-color: #007bff;
            color: #fff;
            border: none;
            border-radius: 5px;
            cursor: pointer;
        }

        .button.button-secondary {
            background-color: transparent;
            border: 2px #007bff solid;
            color: #007bff;
        }

        .loading-state {
            display: none;
            margin-top: 10em;
            font-size: 20px;
            text-align: center;
            margin-bottom: 20px;
        }

        .output-ui {
            display: none;
        }

        .annotated-text {
            line-height: 1.5;
        }

        .tag {
            background-color: #ffc107;
            padding: 2px 5px;
            border-radius: 3px;
        }

        .quote {
            margin-left: 3px;
            border-left: 4px #cbcbcb solid;
            padding-left: 8px;
        }

        /* Media Query for Small Devices */
        @media only screen and (max-width: 600px) {
            .container {
                padding: 10px;
            }
            .text-input {
                height: 150px;
            }
        }

        /* Loading State */
        @keyframes spin {
          0% { transform: rotate(0deg); }
          100% { transform: rotate(360deg); }
        }

        .loading-state {
          display: none;
          text-align: center;
        }

        .loading-icon {
          width: 50px;
          height: 50px;
          border: 4px solid #007bff;
          border-radius: 50%;
          border-top: 4px solid transparent;
          animation: spin 1s linear infinite;
          margin: 0 auto 20px;
        }

        .loading-text {
          font-size: 16px;
          color: #333;
        }
    </style>
</head>
<body>
    <div class="container">
        <header>
            <h1>Propaganda Detector</h1>
        </header>

        <div id="inputUI">
            <textarea id="textInput" class="text-input" placeholder="Paste your text here"></textarea>
            <input type="file" class="file-input" id="fileInput">
            <button id="analyzeBtn" class="analyze-btn button" style="float: right">Analyze</button>
        </div>

        <div id="loadingState" class="loading-state" style="display: none;">
            <div class="loading-icon"></div>
            <p class="loading-text">Stand by – we're uncovering propaganda attempts for you!</p>
        </div>

        <div id="outputUI" class="output-ui" style="display: none;">
            <div id="annotatedText" class="annotated-text"></div>
            <button id="analyzeAnotherBtn" class="button button-secondary" style="float: right; margin-top: 25px">Analyze Another Text</button>
        </div>
    </div>

    <script>
        document.getElementById('analyzeBtn').addEventListener('click', () => {
            if (validateText(document.getElementById('textInput').value)) {
                analyzeText(document.getElementById('textInput').value);
            }
        });

        document.getElementById('fileInput').addEventListener('change', function(event) {
            const file = event.target.files[0];
            const reader = new FileReader();

            reader.onload = function() {
                if (validateText(reader.result)) {
                    analyzeText(reader.result);
                }
            };

            reader.readAsText(file);
        });

        document.getElementById('analyzeAnotherBtn').addEventListener('click', function() {
            document.getElementById('outputUI').style.display = 'none';
            document.getElementById('loadingState').style.display = 'none';
            document.getElementById('inputUI').style.display = 'block';
            document.getElementById('textInput').value = "";
            document.getElementById('fileInput').value = null;
        });

        function validateText(text) {
            if (text.split(/\W+/).length < 50) {
                alert("The text needs to be at least 50 words long.")
                return false;
            }
            return true;
        }

        function analyzeText(text) {
            document.getElementById('inputUI').style.display = 'none';
            document.getElementById('loadingState').style.display = 'block';

            fetch('/analyze', {
                method: 'POST',
                headers: {
                    'Content-Type': 'application/x-www-form-urlencoded'
                },
                body: 'text=' + encodeURIComponent(text)
            })
            .then(response => response.json())
            .then(data => {
                document.getElementById('loadingState').style.display = 'none';
                document.getElementById('outputUI').style.display = 'block';

                const annotatedText = document.getElementById('annotatedText');
                let html = '';
                let startPos = 0;

                data.forEach((span, index) => {
                    html += escapeHtml(text.substring(startPos, span.start_offset));
                    html += `<span
                                class="tag"
                                style="background-color: ${colorMap.get(span.categories[0][0])};"
                                data-spanIndex="${index}"
                                data-category="${span.categories[0][0]}">
                                ${escapeHtml(text.substring(span.start_offset, span.end_offset))}
                            </span>`;
                    startPos = span.end_offset;
                });

                html += escapeHtml(text.substring(startPos));
                html = '<p>' + html.replaceAll('\n\n', '</p><p>') + '</p>';
                annotatedText.innerHTML = html;

                // Add event listener for hovering over tagged spans
                const tags = document.querySelectorAll('.tag');
                tags.forEach(tag => {
                    tag.addEventListener('mouseover', function(event) {
                        let span = data[Number.parseInt(event.target.dataset.spanindex)];

                        const popup = document.createElement('div');
                        const riskClass = riskClasses[Math.floor((span.confidence - 0.5) * 2 * riskClasses.length)]

                        popup.classList.add('popup');
                        popup.innerHTML = `
                            <p>
                                Propaganda risk: <b>${riskClass}</b> (${(span.confidence * 100).toFixed(2)}%)!
                            </p>
                            <p>
                                This is most likely an instance of <b>${categoryToLabel(span.categories[0][0])}</b>:
                            </p>
                            <p class="quote">
                                ${descriptionsMap.get(span.categories[0][0])}
                            </p>`;
                        document.body.appendChild(popup);
                        console.log(event)
                        popup.style.top = (event.pageY - popup.clientHeight / 2) + 'px';
                        popup.style.left = (annotatedText.offsetLeft + annotatedText.clientWidth + 10) + 'px';
                    });
                    tag.addEventListener('mouseout', function() {
                        document.querySelector('.popup').remove();
                    });
                });
            })
            .catch(error => {
                console.error('Error:', error);
                alert("An error occurred. Did you train the models already?");
                document.getElementById('loadingState').style.display = 'none';
                document.getElementById('inputUI').style.display = 'block';
            });
        }

        const colorMap = new Map([
            ['Appeal_to_Authority', '#FFD1DC'], // Pink
            ['Appeal_to_fear-prejudice', '#FFABAB'], // Salmon
            ['Bandwagon', '#FFC3A0'], // Coral
            ['Black-and-White_Fallacy', '#D9A5B3'], // Mauve
            ['Causal_Oversimplification', '#DCC6E0'], // Lavender
            ['Doubt', '#CAAACF'], // Orchid
            ['Exaggeration,Minimisation', '#E6BECA'], // Thistle
            ['Flag-Waving', '#FFDAC1'], // Peach
            ['Loaded_Language', '#E2F0CB'], // Tea Green
            ['Name_Calling,Labeling', '#B5EAD7'], // Magic Mint
            ['Obfuscation,Intentional_Vagueness,Confusion', '#C7CEEA'], // Periwinkle
            ['Red_Herring', '#A2D2FF'], // Sky Blue
            ['Reductio_ad_hitlerum', '#9BF6FF'], // Baby Blue
            ['Repetition', '#A0C4FF'], // Powder Blue
            ['Slogans', '#BDE0FE'], // Carolina Blue
            ['Straw_Men', '#AEE1E1'], // Pale Cyan
            ['Thought-terminating_Cliches', '#D0F4DE'], // Mint Cream
            ['Whataboutism', '#F0E6EF'], // Mauve Glow
        ]);
        
        const descriptionsMap = new Map([
            ['Appeal_to_Authority', 'This technique involves referencing an authority figure to support a claim or argument.'],
            ['Appeal_to_fear-prejudice', 'This technique plays on people\'s fears or prejudices to persuade them.'],
            ['Bandwagon', 'This technique suggests that everyone is doing or believing something, so you should too.'],
            ['Black-and-White_Fallacy', 'This technique presents only two options, ignoring any middle ground or complexities.'],
            ['Causal_Oversimplification', 'This technique oversimplifies a complex issue by attributing it to one simple cause.'],
            ['Doubt', 'This technique seeks to create doubt or uncertainty about a competing argument or viewpoint.'],
            ['Exaggeration,Minimisation', 'This technique involves either exaggerating or minimizing the significance of something.'],
            ['Flag-Waving', 'This technique appeals to patriotic or nationalistic feelings to gain support.'],
            ['Loaded_Language', 'This technique uses emotionally charged language to sway opinion or manipulate emotion.'],
            ['Name_Calling,Labeling', 'This technique involves using derogatory language or labels to discredit an opponent.'],
            ['Obfuscation,Intentional_Vagueness,Confusion', 'This technique involves intentionally using vague or confusing language to obscure the truth.'],
            ['Red_Herring', 'This technique introduces irrelevant information to divert attention from the main issue.'],
            ['Reductio_ad_hitlerum', 'This technique unfairly compares an opponent or their argument to Hitler or the Nazis.'],
            ['Repetition', 'This technique repeats a message or idea multiple times to reinforce its significance.'],
            ['Slogans', 'This technique uses catchy phrases or slogans to simplify complex issues or ideas.'],
            ['Straw_Men', 'This technique misrepresents or exaggerates an opponent\'s argument to make it easier to attack or refute.'],
            ['Thought-terminating_Cliches', 'This technique uses clichéd phrases or slogans to discourage critical thinking or further discussion.'],
            ['Whataboutism', 'This technique deflects criticism by pointing to similar or worse actions committed by others.']
        ]);

        const riskClasses = ['moderate', 'elevated', 'high', 'extreme']

        function categoryToLabel(cat) {
            return cat.replaceAll('_', ' ').replaceAll(',', '/')
        }

        function escapeHtml(unsafe) {
            return unsafe
                 .replace(/&/g, "&amp;")
                 .replace(/</g, "&lt;")
                 .replace(/>/g, "&gt;")
                 .replace(/"/g, "&quot;")
                 .replace(/'/g, "&#039;");
         }
    </script>
</body>
</html>
